package projet_these.es;

import projet_these.et.IslandModel;
import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.ObjectInputStream;
import java.io.FileOutputStream;

/**
 * Implementation of statics Copy/Paste tools for the binary representation of
 * an current IslandModel
 * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
 * @version 01/03/02
 */
public class CopyAndPasteIslandModel
{

        /**
         * Procedure of backup file of the model
         * @throws java.io.IOException the exceptions
         */
        public static void copyIslandModel(IslandModel model) throws IOException
        {

            // Chaine de caractere representant le fichier d'entree sans l'extension
            String bout = (model.nomFic1.endsWith(".para")) ?
                          model.nomFic1.substring(0,
                          model.nomFic1.indexOf(".para", 0)) :
                          model.nomFic1;

            // Creation d'un fichier de copie du modele
            model.modelFile = new File(bout + ".tmp");

            // Initialisation d'un flux d'octets en ecriture  partir d'un fichier
            FileOutputStream FileOut = new FileOutputStream(model.modelFile);

            /* Initialisation d'un flux d'octets en ecriture  partir d'un objet
                     et serialisation de l'objet courant*/
            ObjectOutputStream objOutput = new ObjectOutputStream(FileOut);
            objOutput.writeObject(model);

            // Fermeture du flux d'objet en ecriture
            objOutput.close();
        }


        /**
         * Procedure of initilization file of a model
         * @return a backup copy of the current model
         * @throws java.io.IOException the exceptions
         */
        public static IslandModel pasteIslandModel(File modelFile) throws IOException
        {

            // Copie du model sauvegarde
            IslandModel copie = new IslandModel();

            /* Initialisation d'un flux d'octets en lecture  partir du fichier de
                     sauvegarde du model courant*/
            FileInputStream FileIn = new FileInputStream(modelFile);

            /* Initialisation d'un flux d'octets en lecture  partir d'un objet
                     et collage de la sauvegarde du model courant
                     avec gestion des errreurs possibles*/
            ObjectInputStream objInput = new ObjectInputStream(FileIn);
            try {
                copie = (IslandModel) objInput.readObject();
                objInput.close();
            } catch (ClassNotFoundException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            // Retour de la copie
            return copie;
        }

}
