package projet_these.es;

import java.io.*;




/**
 * Implementation of statics Input/Output tools
 * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
 * @version 01/03/02
 */
public class ReadStandardInput
{


    /**
     * Procedure reading keyboard entry of an integer
     * @return an int representing the integer value
     */
    public static int readInteger() throws IOException
    {

        // Chaine lue
        String ch = "";

        /* Tampon de reserve d'un flux de lecture de caracteres  partir
        de l'entree standard*/
        BufferedReader fluxEntree;
        fluxEntree = new BufferedReader(new InputStreamReader(System.in));

        // Lecture
        try
        {
            ch = fluxEntree.readLine();
            int x = Integer.valueOf(ch).intValue();
            return x;
        }
        catch (Exception excp)
        {
            throw new IOException("Erreur de Lecture d'un entier int");
        }
    }


    /**
     * Procedure reading keyboard entry of a string
     * @return an int representing the string value
     */
    public static String readString() throws IOException
    {

        // Chaine lue
        String ch = "";

        /* Tampon de reserve d'un flux de lecture de caracteres  partir
        de l'entree standard*/
        BufferedReader fluxEntree;
        fluxEntree = new BufferedReader(new InputStreamReader(System.in));

        // Lecture
        try
        {
            ch = fluxEntree.readLine();
            return ch;
        }
        catch (Exception excp)
        {
            throw new IOException("Erreur de Lecture d'une chaine String");
        }
    }


    /**
     * Procedure reading keyboard entry of a float
     * @return an int representing the float value
     */
    public static float readFloat() throws IOException
    {

        // Chaine lue
        String ch = "";

        /* Tampon de reserve d'un flux de lecture de caracteres  partir
        de l'entree standard*/
        BufferedReader fluxEntree;
        fluxEntree = new BufferedReader(new InputStreamReader(System.in));

        // Lecture
        try
        {
            ch = fluxEntree.readLine();
            float x = Float.valueOf(ch).floatValue();
            return x;
        }
        catch (Exception excp)
        {
            throw new IOException("Erreur de Lecture d'un reel float");
        }
    }

}

