package projet_these.et;

import java.util.*;
import java.io.*;
import projet_these.rn.*;




/**
 * Implementation of a individu under the agressive copies hypothesis
 * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
 * @version 20/12/02
 */
public class PopulationPoly1 extends Population
{

    /** 
     * Array of the average population agressive copies number in fontcion of time
     */
    public float[] nb_cop2;

    /** 
     * Agressive Copies Number profile
     */
    protected Vector profile2;

    /**
     * Contructor of initialization of the population
     * @param n Average of the number of two types of copies at initial time
     * @param t Population size
     * @param g int Number of simulations
     */
    public PopulationPoly1(int t, float[] n, int g)
    {
        super(t, g);

        // Agressives copies number mean's table initiation
        nb_cop2 = new float[g];

        // Individuals of the population initiation
        for (int i = 0; i < t; i++)
            population.add(new IndividuPoly1(
                (int)(poidev.poisson(n[0])),
                (int)(poidev.poisson(n[1]))));

        // Initiation of copies profile
        this.setFrequencies();

        // Initiation of wmax
        setWmax();

        // Initisation of initial real mean
        moyenne(0);
    }


    /**
    * Calculation procedure of the average number of copies to a generation
    * temps
    * @param temps The current generation
    */
    protected void moyenne(int temps)
    {

        // Initiation of average copies number
        float mean = 0f;

        super.moyenne(temps);

        // Sum calculus
        for (int i = 0; i < profile2.size(); i++)
            mean += ((float) i) * ((Integer) profile2.get(i)).floatValue();

        // Mean calculus
        nb_cop2[temps] = mean / (float) taille;
    }


    /**
     * Procedure setting the profiles of the population
     */
    protected void setFrequencies()
    {
        Vector freq = new Vector();
        Vector freq2 = new Vector();
        super.setFrequencies(this.population, freq);
        this.setFrequencies(this.population, freq2);
        this.profile = freq;
        this.profile2 = freq2;
    }


    /**
     * Procedure setting a profile
     * @param pop Vector populations
     * @param freq The agressive copy profile
     */
    protected void setFrequencies(Vector pop, Vector freq)
    {
        // Class index in profile vector
        int index;

        // Initiation of vector with zeros
        freq.setSize(100);
        for (int i = 0; i < freq.size(); i++)
        {
            freq.setElementAt(new Integer(0), i);
        }

        // Construction of vectors profiles
        for (int i = 0; i < pop.size(); i++)
        {
            index = ((IndividuPoly1) pop.elementAt(i)).nb_copies2;
            if(index >= freq.size())
                freq.setSize(index + 1);
            freq.setElementAt(new Integer(((Integer) freq.
                elementAt(index)).intValue() + 1), index);
        }

    }


    /**
     * Functin returning all copies number
     * @param   generation  The period in witch copies number would be return
     * @return              Total number of copies
     */
    /*protected float getAllCopiesNb(int generation)
    {
        return (this.nb_cop[generation] + this.nb_cop2[generation]);
    }*/

}