package projet_these.ig;

import java.awt.*;

import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import projet_these.es.OutPutDataFiles;
import java.io.IOException;



/**
 * Title : Entries
 * Description : Recall all the entries
 * Copyright :    Copyright (c) 2002
 * Society : UMR CNRS 5558 - "BBE"
 * @author Gregory Deceliere
 * @version 1.0
 */
public class Entries extends JInternalFrame
{
    
    
    /**
     * Main frame
     */
    protected MainFrame super_frame;
    
    /**
     * Panel with a sroller
     */
    private JScrollPane jScrollPane1;
    
    /**
     * Compomnent for text
     */
    private JTextArea info;
    
    
    /**
     * Constructor of initialization of Entries
     * @param super_frame The main frame
     */
    public Entries(MainFrame super_frame)
    {
        
        //Constructor of a JInternalFrame no title, not resizable, not maximizable
        //iconifiable
        super("Entries", true, false, false, true);
        
        // Capture of the main frame reference
        setsuperFrame(super_frame);
        
        // GridBagLayout management of layout
        getContentPane().setLayout(new GridBagLayout());
        
        // Scalling and positionning of internal frame
        setSize(570, 370);
        setLocation(10, 10);
        
        // Creation of an informative area about model parameters
        info = new JTextArea("\n" + getsuperFrame().getTitle() + "\n\n" +
                getsuperFrame().model.getInfo());
        info.setEditable(false);
        info.setBackground(Color.black);
        info.setForeground(Color.white);
        jScrollPane1 = new JScrollPane(info);
        util_IG.addComposantContentPane(getContentPane(), jScrollPane1,
                GridBagConstraints.CENTER, 0, 0, 1, 1,
                new Insets(5, 0, 0, 0),
                (int) (0.925 * getSize().width),
                (int) (0.775 * getSize().height) - 10);
        
        // Frame must be visible
        setVisible(true);
    }
    
    
    /**
     * Procedure returning a reference to main frame
     * @return MainFrame the main frame
     */
    protected MainFrame getsuperFrame()
    {
        
        return super_frame;
    }
    
    
    /**
     * Procedure setting the reference to main frame
     * @param sf MainFrame the setted reference of main frame
     */
    protected void setsuperFrame(MainFrame sf)
    {
        
        super_frame = sf;
    }
    
    
    /**
     * Procedure updating the entries
     */
    protected void upDate()
    {
        
        info.setText("\n" + getsuperFrame().getTitle() + "\n\n" +
                getsuperFrame().model.getInfo());
    }
    
}
